diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/he/he-phy.h ns-3.40/src/wifi/model/he/he-phy.h
--- ns-3.39/src/wifi/model/he/he-phy.h	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/he/he-phy.h	2023-09-27 13:30:37.906839800 -0700
@@ -116,7 +116,7 @@
     void NotifyCcaBusy(const Ptr<const WifiPpdu> ppdu,
                        Time duration,
                        WifiChannelListType channelType) override;
-    bool CanStartRx(Ptr<const WifiPpdu> ppdu, uint16_t txChannelWidth) const override;
+    bool CanStartRx(Ptr<const WifiPpdu> ppdu) const override;
     Ptr<const WifiPpdu> GetRxPpduFromTxPpdu(Ptr<const WifiPpdu> ppdu) override;
 
     /**
@@ -152,16 +152,16 @@
     /**
      * \param txVector the transmission parameters used for the HE TB PPDU
      *
-     * \return the duration of the non-OFDMA portion of the HE TB PPDU.
+     * \return the duration of the non-HE portion of the HE TB PPDU.
      */
-    virtual Time CalculateNonOfdmaDurationForHeTb(const WifiTxVector& txVector) const;
+    virtual Time CalculateNonHeDurationForHeTb(const WifiTxVector& txVector) const;
 
     /**
      * \param txVector the transmission parameters used for the HE MU PPDU
      *
-     * \return the duration of the non-OFDMA portion of the HE MU PPDU.
+     * \return the duration of the non-HE portion of the HE MU PPDU.
      */
-    virtual Time CalculateNonOfdmaDurationForHeMu(const WifiTxVector& txVector) const;
+    virtual Time CalculateNonHeDurationForHeMu(const WifiTxVector& txVector) const;
 
     /**
      * Get the band in the TX spectrum associated with the RU used by the PSDU
@@ -215,15 +215,15 @@
     void SetTrigVector(const WifiTxVector& trigVector, Time validity);
 
     /**
-     * Get the center frequency of the non-OFDMA part of the current TxVector for the
+     * Get the center frequency of the non-HE portion of the current TxVector for the
      * given STA-ID.
      * Note this method is only to be used for UL MU.
      *
      * \param txVector the TXVECTOR that has the RU allocation
      * \param staId the STA-ID of the station taking part of the UL MU
-     * \return the center frequency in MHz corresponding to the non-OFDMA part of the HE TB PPDU
+     * \return the center frequency in MHz corresponding to the non-HE portion of the HE TB PPDU
      */
-    uint16_t GetCenterFrequencyForNonOfdmaPart(const WifiTxVector& txVector, uint16_t staId) const;
+    uint16_t GetCenterFrequencyForNonHePart(const WifiTxVector& txVector, uint16_t staId) const;
 
     /**
      * Sets the OBSS-PD algorithm.
@@ -451,21 +451,6 @@
                                                           HeRu::SubcarrierRange subcarrierRange,
                                                           uint8_t bandIndex = 0);
 
-    /// Map a spectrum band associated with an RU to the RU specification
-    using RuBands = std::map<WifiSpectrumBandInfo, HeRu::RuSpec>;
-
-    /**
-     * Static function to compute the RU bands that belong to a given channel width.
-     *
-     * \param phy the PHY that issued the function call
-     * \param channelWidth the channelWidth the channel width in MHz
-     * \param guardBandwidth width of the guard band in MHz
-     * \returns the computed RU bands that belong to the channel width
-     */
-    static RuBands GetRuBands(Ptr<const WifiPhy> phy,
-                              uint16_t channelWidth,
-                              uint16_t guardBandwidth);
-
   protected:
     PhyFieldRxStatus ProcessSig(Ptr<Event> event,
                                 PhyFieldRxStatus status,
@@ -493,6 +478,9 @@
     uint32_t GetMaxPsduSize() const override;
     WifiConstPsduMap GetWifiConstPsduMap(Ptr<const WifiPsdu> psdu,
                                          const WifiTxVector& txVector) const override;
+    void HandleRxPpduWithSameContent(Ptr<Event> event,
+                                     Ptr<const WifiPpdu> ppdu,
+                                     RxPowerWattPerChannelBand& rxPower) override;
 
     /**
      * Process SIG-A, perform amendment-specific actions, and
@@ -523,13 +511,13 @@
     virtual uint32_t GetSigBSize(const WifiTxVector& txVector) const;
 
     /**
-     * Start receiving the PSDU (i.e. the first symbol of the PSDU has arrived) of an OFDMA
-     * transmission. This function is called upon the RX event corresponding to the OFDMA part of
+     * Start receiving the PSDU (i.e. the first symbol of the PSDU has arrived) of an MU
+     * transmission. This function is called upon the RX event corresponding to the HE portion of
      * the MU PPDU.
      *
-     * \param event the event holding incoming OFDMA part of the PPDU's information
+     * \param event the event holding incoming HE portion of the PPDU's information
      */
-    void StartReceiveOfdmaPayload(Ptr<Event> event);
+    void StartReceiveMuPayload(Ptr<Event> event);
 
     /**
      * Return the rate (in bps) of the non-HT Reference Rate
@@ -563,8 +551,8 @@
     uint64_t m_currentMuPpduUid;    //!< UID of the HE MU or HE TB PPDU being received
 
     std::map<uint16_t /* STA-ID */, EventId>
-        m_beginOfdmaPayloadRxEvents; //!< the beginning of the OFDMA payload reception events
-                                     //!< (indexed by STA-ID)
+        m_beginMuPayloadRxEvents; //!< the beginning of the MU payload reception events (indexed by
+                                  //!< STA-ID)
 
     EndOfHeSigACallback m_endOfHeSigACallback;      //!< end of HE-SIG-A callback
     std::optional<WifiTxVector> m_trigVector;       //!< the TRIGVECTOR
@@ -590,17 +578,17 @@
                                                  HePpdu::TxPsdFlag flag) const;
 
     /**
-     * Start the transmission of the OFDMA part of the MU PPDU.
+     * Start the transmission of the HE portion of the MU PPDU.
      *
      * \param ppdu the PPDU
      * \param txPowerDbm the total TX power in dBm
      * \param txPowerSpectrum the TX PSD
-     * \param ofdmaDuration the duration of the OFDMA part
+     * \param hePortionDuration the duration of the HE portion
      */
-    void StartTxOfdma(Ptr<const WifiPpdu> ppdu,
-                      double txPowerDbm,
-                      Ptr<SpectrumValue> txPowerSpectrum,
-                      Time ofdmaDuration);
+    void StartTxHePortion(Ptr<const WifiPpdu> ppdu,
+                          double txPowerDbm,
+                          Ptr<SpectrumValue> txPowerSpectrum,
+                          Time hePortionDuration);
 
     /**
      * Notify PHY state helper to switch to CCA busy state,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/he/he-ppdu.cc ns-3.40/src/wifi/model/he/he-ppdu.cc
--- ns-3.39/src/wifi/model/he/he-ppdu.cc	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/he/he-ppdu.cc	2023-09-27 13:30:37.906839800 -0700
@@ -29,6 +29,8 @@
 #include "ns3/wifi-psdu.h"
 #include "ns3/wifi-utils.h"
 
+#include <algorithm>
+
 namespace ns3
 {
 
@@ -129,10 +131,15 @@
     else if (ns3::IsDlMu(m_preamble))
     {
         const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(20);
+        const uint8_t noMuMimoUsers{0};
         m_heSig.emplace<HeMuSigHeader>(HeMuSigHeader{
             .m_bssColor = bssColor,
             .m_bandwidth = GetChannelWidthEncodingFromMhz(txVector.GetChannelWidth()),
             .m_sigBMcs = txVector.GetSigBMode().GetMcsValue(),
+            .m_muMimoUsers = (txVector.IsSigBCompression()
+                                  ? GetMuMimoUsersEncoding(txVector.GetHeMuUserInfoMap().size())
+                                  : noMuMimoUsers),
+            .m_sigBCompression = txVector.IsSigBCompression(),
             .m_giLtfSize = GetGuardIntervalAndNltfEncoding(txVector.GetGuardInterval(),
                                                            2 /*NLTF currently unused*/),
             .m_ruAllocation = txVector.GetRuAllocation(p20Index),
@@ -194,7 +201,11 @@
         txVector.SetChannelWidth(GetChannelWidthMhzFromEncoding(heSigHeader->m_bandwidth));
         txVector.SetGuardInterval(GetGuardIntervalFromEncoding(heSigHeader->m_giLtfSize));
         txVector.SetBssColor(heSigHeader->m_bssColor);
-        SetHeMuUserInfos(txVector, heSigHeader->m_ruAllocation, heSigHeader->m_contentChannels);
+        SetHeMuUserInfos(txVector,
+                         heSigHeader->m_ruAllocation,
+                         heSigHeader->m_contentChannels,
+                         heSigHeader->m_sigBCompression,
+                         GetMuMimoUsersFromEncoding(heSigHeader->m_muMimoUsers));
         txVector.SetSigBMode(HePhy::GetVhtMcs(heSigHeader->m_sigBMcs));
         const auto p20Index = m_operatingChannel.GetPrimaryChannelIndex(20);
         txVector.SetRuAllocation(heSigHeader->m_ruAllocation, p20Index);
@@ -202,25 +213,37 @@
         {
             txVector.SetCenter26ToneRuIndication(heSigHeader->m_center26ToneRuIndication.value());
         }
+        if (heSigHeader->m_sigBCompression)
+        {
+            NS_ASSERT(GetMuMimoUsersFromEncoding(heSigHeader->m_muMimoUsers) ==
+                      txVector.GetHeMuUserInfoMap().size());
+        }
     }
 }
 
 void
 HePpdu::SetHeMuUserInfos(WifiTxVector& txVector,
                          const RuAllocation& ruAllocation,
-                         const HeSigBContentChannels& contentChannels) const
+                         const HeSigBContentChannels& contentChannels,
+                         bool sigBcompression,
+                         uint8_t numMuMimoUsers) const
 {
-    auto contentChannelIndex = 0;
+    std::size_t contentChannelIndex = 0;
     for (const auto& contentChannel : contentChannels)
     {
-        auto numRusLeft = 0;
-        auto ruAllocIndex = contentChannelIndex;
+        std::size_t numRusLeft = 0;
+        std::size_t numUsersLeft = 0;
+        std::size_t ruAllocIndex = contentChannelIndex;
         for (const auto& userInfo : contentChannel)
         {
             if (userInfo.staId == NO_USER_STA_ID)
             {
                 continue;
             }
+            if (ruAllocIndex >= ruAllocation.size())
+            {
+                break;
+            }
             auto ruSpecs = HeRu::GetRuSpecs(ruAllocation.at(ruAllocIndex));
             if (ruSpecs.empty())
             {
@@ -230,14 +253,27 @@
             {
                 numRusLeft = ruSpecs.size();
             }
+            if (numUsersLeft == 0)
+            {
+                if (sigBcompression)
+                {
+                    numUsersLeft = numMuMimoUsers;
+                }
+                else
+                {
+                    // not MU-MIMO
+                    numUsersLeft = 1;
+                }
+            }
             auto ruIndex = (ruSpecs.size() - numRusLeft);
             auto ruSpec = ruSpecs.at(ruIndex);
             auto ruType = ruSpec.GetRuType();
             if ((ruAllocation.size() == 8) && (ruType == HeRu::RU_996_TONE) &&
-                (std::all_of(
-                    contentChannel.cbegin(),
-                    contentChannel.cend(),
-                    [&userInfo](const auto& item) { return userInfo.staId == item.staId; })))
+                (((txVector.GetChannelWidth() == 160) && sigBcompression) ||
+                 std::all_of(
+                     contentChannel.cbegin(),
+                     contentChannel.cend(),
+                     [&userInfo](const auto& item) { return userInfo.staId == item.staId; })))
             {
                 NS_ASSERT(txVector.GetChannelWidth() == 160);
                 ruType = HeRu::RU_2x996_TONE;
@@ -259,12 +295,13 @@
                                           userInfo.mcs,
                                           userInfo.nss});
             }
-            if (ruType == HeRu::RU_2x996_TONE)
+            if ((ruType == HeRu::RU_2x996_TONE) && !sigBcompression)
             {
                 return;
             }
             numRusLeft--;
-            if (numRusLeft == 0)
+            numUsersLeft--;
+            if (numRusLeft == 0 && numUsersLeft == 0)
             {
                 ruAllocIndex += (2 * numRuAllocsInContentChannel);
             }
@@ -277,7 +314,7 @@
 HePpdu::GetTxDuration() const
 {
     Time ppduDuration = Seconds(0);
-    const WifiTxVector& txVector = GetTxVector();
+    const auto& txVector = GetTxVector();
     const auto length = m_lSig.GetLength();
     const auto tSymbol = NanoSeconds(12800 + txVector.GetGuardInterval());
     const auto preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
@@ -378,10 +415,10 @@
 }
 
 uint16_t
-HePpdu::GetTransmissionChannelWidth() const
+HePpdu::GetTxChannelWidth() const
 {
-    const WifiTxVector& txVector = GetTxVector();
-    if (txVector.IsUlMu() && GetStaId() != SU_STA_ID)
+    if (const auto& txVector = GetTxVector();
+        txVector.IsValid() && txVector.IsUlMu() && GetStaId() != SU_STA_ID)
     {
         TxPsdFlag flag = GetTxPsdFlag();
         uint16_t ruWidth = HeRu::GetBandwidth(txVector.GetRu(GetStaId()).GetRuType());
@@ -392,7 +429,7 @@
     }
     else
     {
-        return OfdmPpdu::GetTransmissionChannelWidth();
+        return OfdmPpdu::GetTxChannelWidth();
     }
 }
 
@@ -446,17 +483,37 @@
 }
 
 std::pair<std::size_t, std::size_t>
-HePpdu::GetNumRusPerHeSigBContentChannel(uint16_t channelWidth, const RuAllocation& ruAllocation)
+HePpdu::GetNumRusPerHeSigBContentChannel(uint16_t channelWidth,
+                                         const RuAllocation& ruAllocation,
+                                         bool sigBCompression,
+                                         uint8_t numMuMimoUsers)
 {
-    // MU-MIMO is not handled for now, i.e. one station per RU
-    NS_ASSERT_MSG(!ruAllocation.empty(), "RU allocation is not set");
-    NS_ASSERT_MSG(ruAllocation.size() == channelWidth / 20,
-                  "RU allocation is not consistent with packet bandwidth");
-
     std::pair<std::size_t /* number of RUs in content channel 1 */,
               std::size_t /* number of RUs in content channel 2 */>
         chSize{0, 0};
 
+    if (sigBCompression)
+    {
+        // If the HE-SIG-B Compression field in the HE-SIG-A field of an HE MU PPDU is 1,
+        // for bandwidths larger than 20 MHz, the AP performs an equitable split of
+        // the User fields between two HE-SIG-B content channels
+        if (channelWidth == 20)
+        {
+            return {numMuMimoUsers, 0};
+        }
+        chSize.first = numMuMimoUsers / 2;
+        chSize.second = numMuMimoUsers / 2;
+        if (numMuMimoUsers != (chSize.first + chSize.second))
+        {
+            chSize.first++;
+        }
+        return chSize;
+    }
+
+    NS_ASSERT_MSG(!ruAllocation.empty(), "RU allocation is not set");
+    NS_ASSERT_MSG(ruAllocation.size() == channelWidth / 20,
+                  "RU allocation is not consistent with packet bandwidth");
+
     switch (channelWidth)
     {
     case 40:
@@ -505,19 +562,20 @@
     }
 
     const auto& orderedMap = txVector.GetUserInfoMapOrderedByRus(p20Index);
-    for (const auto& [ru, staId] : orderedMap)
+    for (const auto& [ru, staIds] : orderedMap)
     {
-        auto ruType = ru.GetRuType();
-        auto ruIdx = ru.GetIndex();
-        const auto& userInfo = txVector.GetHeMuUserInfo(staId);
-        NS_ASSERT(ru == userInfo.ru);
-
-        if (ruType > HeRu::RU_242_TONE)
+        const auto ruType = ru.GetRuType();
+        if ((ruType > HeRu::RU_242_TONE) && !txVector.IsSigBCompression())
         {
             for (auto i = 0; i < ((ruType == HeRu::RU_2x996_TONE) ? 2 : 1); ++i)
             {
-                contentChannels[0].push_back({staId, userInfo.nss, userInfo.mcs});
-                contentChannels[1].push_back({staId, userInfo.nss, userInfo.mcs});
+                for (auto staId : staIds)
+                {
+                    const auto& userInfo = txVector.GetHeMuUserInfo(staId);
+                    NS_ASSERT(ru == userInfo.ru);
+                    contentChannels[0].push_back({staId, userInfo.nss, userInfo.mcs});
+                    contentChannels[1].push_back({staId, userInfo.nss, userInfo.mcs});
+                }
             }
             continue;
         }
@@ -525,55 +583,84 @@
         std::size_t numRus = (ruType >= HeRu::RU_242_TONE)
                                  ? 1
                                  : HeRu::m_heRuSubcarrierGroups.at({20, ruType}).size();
-        if (((ruIdx - 1) / numRus) % 2 == 0)
-        {
-            contentChannels.at(0).push_back({staId, userInfo.nss, userInfo.mcs});
-        }
-        else
+        const auto ruIdx = ru.GetIndex();
+        for (auto staId : staIds)
         {
-            contentChannels.at(1).push_back({staId, userInfo.nss, userInfo.mcs});
+            const auto& userInfo = txVector.GetHeMuUserInfo(staId);
+            NS_ASSERT(ru == userInfo.ru);
+            std::size_t ccIndex{0};
+            if (channelWidth < 40)
+            {
+                // only one content channel
+                ccIndex = 0;
+            }
+            else if (txVector.IsSigBCompression())
+            {
+                // equal split
+                ccIndex = (contentChannels.at(0).size() <= contentChannels.at(1).size()) ? 0 : 1;
+            }
+            else // MU-MIMO
+            {
+                ccIndex = (((ruIdx - 1) / numRus) % 2 == 0) ? 0 : 1;
+            }
+            contentChannels.at(ccIndex).push_back({staId, userInfo.nss, userInfo.mcs});
         }
     }
 
-    // Add unassigned RUs
-    auto numNumRusPerHeSigBContentChannel =
-        GetNumRusPerHeSigBContentChannel(channelWidth, txVector.GetRuAllocation(p20Index));
-    std::size_t contentChannelIndex = 1;
-    for (auto& contentChannel : contentChannels)
+    const auto isSigBCompression = txVector.IsSigBCompression();
+    if (!isSigBCompression)
     {
-        const auto totalUsersInContentChannel = (contentChannelIndex == 1)
-                                                    ? numNumRusPerHeSigBContentChannel.first
-                                                    : numNumRusPerHeSigBContentChannel.second;
-        NS_ASSERT(contentChannel.size() <= totalUsersInContentChannel);
-        std::size_t unallocatedRus = totalUsersInContentChannel - contentChannel.size();
-        for (std::size_t i = 0; i < unallocatedRus; i++)
+        // Add unassigned RUs
+        auto numNumRusPerHeSigBContentChannel = GetNumRusPerHeSigBContentChannel(
+            channelWidth,
+            txVector.GetRuAllocation(p20Index),
+            isSigBCompression,
+            isSigBCompression ? txVector.GetHeMuUserInfoMap().size() : 0);
+        std::size_t contentChannelIndex = 1;
+        for (auto& contentChannel : contentChannels)
         {
-            contentChannel.push_back({NO_USER_STA_ID, 0, 0});
+            const auto totalUsersInContentChannel = (contentChannelIndex == 1)
+                                                        ? numNumRusPerHeSigBContentChannel.first
+                                                        : numNumRusPerHeSigBContentChannel.second;
+            NS_ASSERT(contentChannel.size() <= totalUsersInContentChannel);
+            std::size_t unallocatedRus = totalUsersInContentChannel - contentChannel.size();
+            for (std::size_t i = 0; i < unallocatedRus; i++)
+            {
+                contentChannel.push_back({NO_USER_STA_ID, 0, 0});
+            }
+            contentChannelIndex++;
         }
-        contentChannelIndex++;
     }
 
     return contentChannels;
 }
 
 uint32_t
-HePpdu::GetSigBFieldSize(uint16_t channelWidth, const RuAllocation& ruAllocation)
+HePpdu::GetSigBFieldSize(uint16_t channelWidth,
+                         const RuAllocation& ruAllocation,
+                         bool sigBCompression,
+                         std::size_t numMuMimoUsers)
 {
     // Compute the number of bits used by common field.
-    // Assume that compression bit in HE-SIG-A is not set (i.e. not
-    // full band MU-MIMO); the field is present.
-    auto commonFieldSize = 4 /* CRC */ + 6 /* tail */;
-    if (channelWidth <= 40)
-    {
-        commonFieldSize += 8; // only one allocation subfield
-    }
-    else
+    uint32_t commonFieldSize = 0;
+    if (!sigBCompression)
     {
-        commonFieldSize +=
-            8 * (channelWidth / 40) /* one allocation field per 40 MHz */ + 1 /* center RU */;
+        commonFieldSize = 4 /* CRC */ + 6 /* tail */;
+        if (channelWidth <= 40)
+        {
+            commonFieldSize += 8; // only one allocation subfield
+        }
+        else
+        {
+            commonFieldSize +=
+                8 * (channelWidth / 40) /* one allocation field per 40 MHz */ + 1 /* center RU */;
+        }
     }
 
-    auto numRusPerContentChannel = GetNumRusPerHeSigBContentChannel(channelWidth, ruAllocation);
+    auto numRusPerContentChannel = GetNumRusPerHeSigBContentChannel(channelWidth,
+                                                                    ruAllocation,
+                                                                    sigBCompression,
+                                                                    numMuMimoUsers);
     auto maxNumRusPerContentChannel =
         std::max(numRusPerContentChannel.first, numRusPerContentChannel.second);
     auto maxNumUserBlockFields = maxNumRusPerContentChannel /
@@ -698,4 +785,17 @@
     return nsts + 1;
 }
 
+uint8_t
+HePpdu::GetMuMimoUsersEncoding(uint8_t nUsers)
+{
+    NS_ASSERT(nUsers <= 8);
+    return (nUsers - 1);
+}
+
+uint8_t
+HePpdu::GetMuMimoUsersFromEncoding(uint8_t encoding)
+{
+    return (encoding + 1);
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/he/he-ppdu.h ns-3.40/src/wifi/model/he/he-ppdu.h
--- ns-3.39/src/wifi/model/he/he-ppdu.h	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/he/he-ppdu.h	2023-09-27 13:30:37.906839800 -0700
@@ -89,10 +89,12 @@
     struct HeMuSigHeader
     {
         // HE-SIG-A fields
-        uint8_t m_bssColor{0};  ///< BSS color field
-        uint8_t m_bandwidth{0}; ///< Bandwidth field
-        uint8_t m_sigBMcs{0};   ///< HE-SIG-B MCS
-        uint8_t m_giLtfSize{0}; ///< GI+LTF Size field
+        uint8_t m_bssColor{0};        ///< BSS color field
+        uint8_t m_bandwidth{0};       ///< Bandwidth field
+        uint8_t m_sigBMcs{0};         ///< HE-SIG-B MCS
+        uint8_t m_muMimoUsers;        ///< MU-MIMO users
+        uint8_t m_sigBCompression{0}; ///< SIG-B compression
+        uint8_t m_giLtfSize{0};       ///< GI+LTF Size field
 
         // HE-SIG-B fields
         RuAllocation m_ruAllocation; //!< RU allocations that are going to be carried in SIG-B
@@ -152,7 +154,7 @@
     Ptr<WifiPpdu> Copy() const override;
     WifiPpduType GetType() const override;
     uint16_t GetStaId() const override;
-    uint16_t GetTransmissionChannelWidth() const override;
+    uint16_t GetTxChannelWidth() const override;
 
     /**
      * Get the payload of the PPDU.
@@ -187,18 +189,21 @@
     void UpdateTxVectorForUlMu(const std::optional<WifiTxVector>& trigVector) const;
 
     /**
-     * Get the number of RUs per HE-SIG-B content channel.
-     * This is applicable only for MU. MU-MIMO (i.e. multiple stations
-     * per RU) is not supported yet.
+     * Get the number of STAs per HE-SIG-B content channel.
+     * This is applicable only for MU.
      * See section 27.3.10.8.3 of IEEE 802.11ax draft 4.0.
      *
      * \param channelWidth the channel width occupied by the PPDU (in MHz)
      * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
+     * \param sigBCompression flag whether SIG-B compression is used by the PPDU
+     * \param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
      * \return a pair containing the number of RUs in each HE-SIG-B content channel (resp. 1 and 2)
      */
     static std::pair<std::size_t, std::size_t> GetNumRusPerHeSigBContentChannel(
         uint16_t channelWidth,
-        const RuAllocation& ruAllocation);
+        const RuAllocation& ruAllocation,
+        bool sigBCompression,
+        uint8_t numMuMimoUsers);
 
     /**
      * Get the HE SIG-B content channels for a given PPDU
@@ -215,9 +220,14 @@
      * Get variable length HE SIG-B field size
      * \param channelWidth the channel width occupied by the PPDU (in MHz)
      * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
+     * \param sigBCompression flag whether SIG-B compression is used by the PPDU
+     * \param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
      * \return field size in bytes
      */
-    static uint32_t GetSigBFieldSize(uint16_t channelWidth, const RuAllocation& ruAllocation);
+    static uint32_t GetSigBFieldSize(uint16_t channelWidth,
+                                     const RuAllocation& ruAllocation,
+                                     bool sigBCompression,
+                                     std::size_t numMuMimoUsers);
 
   protected:
     /**
@@ -233,10 +243,14 @@
      * \param txVector the TXVECTOR to set its HeMuUserInfoMap
      * \param ruAllocation the RU_ALLOCATION per 20 MHz
      * \param contentChannels the HE-SIG-B content channels
+     * \param sigBCompression flag whether SIG-B compression is used by the PPDU
+     * \param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
      */
     void SetHeMuUserInfos(WifiTxVector& txVector,
                           const RuAllocation& ruAllocation,
-                          const HeSigBContentChannels& contentChannels) const;
+                          const HeSigBContentChannels& contentChannels,
+                          bool sigBCompression,
+                          uint8_t numMuMimoUsers) const;
 
     /**
      * Convert channel width expressed in MHz to bandwidth field encoding in HE-SIG-A.
@@ -287,6 +301,22 @@
      */
     static uint16_t GetGuardIntervalFromEncoding(uint8_t giAndNltfSize);
 
+    /**
+     * Convert number of MU-MIMO users to its encoding in HE-SIG-A.
+     *
+     * \param nUsers the number of MU-MIMO users
+     * \return the number of MU-MIMO users to its encoding in HE-SIG-A
+     */
+    static uint8_t GetMuMimoUsersEncoding(uint8_t nUsers);
+
+    /**
+     * Convert number of MU-MIMO users from its encoding in HE-SIG-A.
+     *
+     * \param encoding the number of MU-MIMO users encoded in HE-SIG-A
+     * \return the number of MU-MIMO users from its encoding in HE-SIG-A
+     */
+    static uint8_t GetMuMimoUsersFromEncoding(uint8_t encoding);
+
     mutable TxPsdFlag m_txPsdFlag; //!< the transmit power spectral density flag
 
   private:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/he/he-ru.cc ns-3.40/src/wifi/model/he/he-ru.cc
--- ns-3.39/src/wifi/model/he/he-ru.cc	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/he/he-ru.cc	2023-09-27 13:30:37.906839800 -0700
@@ -23,6 +23,7 @@
 #include "ns3/assert.h"
 
 #include <optional>
+#include <tuple>
 
 namespace ns3
 {
@@ -890,4 +891,14 @@
     return !(*this == other);
 }
 
+bool
+HeRu::RuSpec::operator<(const RuSpec& other) const
+{
+    // we do not compare the RU PHY indices because they may be uninitialized for
+    // one of the compared RUs. This event should not cause the comparison to evaluate
+    // to false
+    return std::tie(m_ruType, m_index, m_primary80MHz) <
+           std::tie(other.m_ruType, other.m_index, other.m_primary80MHz);
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/he/he-ru.h ns-3.40/src/wifi/model/he/he-ru.h
--- ns-3.39/src/wifi/model/he/he-ru.h	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/he/he-ru.h	2023-09-27 13:30:37.906839800 -0700
@@ -119,6 +119,13 @@
          * \return true if this RU differs from the given RU, false otherwise
          */
         bool operator!=(const RuSpec& other) const;
+        /**
+         * Compare this RU to the given RU.
+         *
+         * \param other the given RU
+         * \return true if this RU is smaller than the given RU, false otherwise
+         */
+        bool operator<(const RuSpec& other) const;
 
       private:
         RuType m_ruType;     //!< RU type
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/he/rr-multi-user-scheduler.cc ns-3.40/src/wifi/model/he/rr-multi-user-scheduler.cc
--- ns-3.39/src/wifi/model/he/rr-multi-user-scheduler.cc	2023-07-05 14:23:48.113428400 -0700
+++ ns-3.40/src/wifi/model/he/rr-multi-user-scheduler.cc	2023-09-27 13:30:37.906839800 -0700
@@ -708,8 +708,17 @@
                     WifiTxVector suTxVector =
                         GetWifiRemoteStationManager(m_linkId)->GetDataTxVector(mpdu->GetHeader(),
                                                                                m_allowedWidth);
+
                     WifiTxVector txVectorCopy = m_txParams.m_txVector;
 
+                    // the first candidate STA determines the preamble type for the DL MU PPDU
+                    if (m_candidates.empty() &&
+                        suTxVector.GetPreambleType() == WIFI_PREAMBLE_EHT_MU)
+                    {
+                        m_txParams.m_txVector.SetPreambleType(WIFI_PREAMBLE_EHT_MU);
+                        m_txParams.m_txVector.SetEhtPpduType(0); // indicates DL OFDMA transmission
+                    }
+
                     m_txParams.m_txVector.SetHeMuUserInfo(staIt->aid,
                                                           {{currRuType, 1, true},
                                                            suTxVector.GetMode().GetMcsValue(),
@@ -737,17 +746,6 @@
             }
         }
 
-        // the first candidate STA determines the preamble type for the DL MU PPDU
-        if (m_candidates.size() == 1)
-        {
-            if (m_apMac->GetEhtSupported() && m_apMac->GetEhtSupported(staIt->address))
-            {
-                m_txParams.m_txVector.SetPreambleType(WIFI_PREAMBLE_EHT_MU);
-                m_txParams.m_txVector.SetEhtPpduType(0); // indicates DL OFDMA transmission
-            }
-            // TODO otherwise, make sure the TX width does not exceed 160 MHz
-        }
-
         // move to the next station in the list
         staIt++;
     }
